## org.apache.commons.collections.map
Class PredicatedSortedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.PredicatedMap
              org.apache.commons.collections.map.PredicatedSortedMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map, java.util.SortedMap

    public class PredicatedSortedMap

extends PredicatedMap
implements java.util.SortedMap

Decorates another `SortedMap` to validate that additions match a specified predicate.

This map exists to provide validation for the decorated map. It is normally created to decorate an empty map. If an object cannot be added to the map, an IllegalArgumentException is thrown.

One usage would be to ensure that no null keys are added to the map.

    SortedMap map = PredicatedSortedSet.decorate(new TreeMap(), NotNullPredicate.INSTANCE, null);

Note that PredicatedSortedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedSortedMap(java.util.SortedMap)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.PredicatedMap
`keyPredicate, valuePredicate`

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `PredicatedSortedMap(java.util.SortedMap map, Predicate keyPredicate, Predicate valuePredicate)` Constructor that wraps (not copies).

Method Summary
`java.util.Comparator` `comparator()`
`static java.util.SortedMap` `decorate(java.util.SortedMap map, Predicate keyPredicate, Predicate valuePredicate)` Factory method to create a predicated (validating) sorted map.
`java.util.Set` `entrySet()`
`java.lang.Object` `firstKey()`
`protected java.util.SortedMap` `getSortedMap()` Gets the map being decorated.
`java.util.SortedMap` `headMap(java.lang.Object toKey)`
`java.lang.Object` `lastKey()`
`java.util.SortedMap` `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` `tailMap(java.lang.Object fromKey)`

Methods inherited from class org.apache.commons.collections.map.PredicatedMap
`checkSetValue, decorate, isSetValueChecking, put, putAll, validate`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, keySet, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### PredicatedSortedMap

    protected PredicatedSortedMap(java.util.SortedMap map,
                                  Predicate keyPredicate,
                                  Predicate valuePredicate)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `keyPredicate` - the predicate to validate the keys, null means no check
    `valuePredicate` - the predicate to validate to values, null means no check
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

Method Detail

### decorate

    public static java.util.SortedMap decorate(java.util.SortedMap map,
                                               Predicate keyPredicate,
                                               Predicate valuePredicate)

  Factory method to create a predicated (validating) sorted map.

  If there are any elements already in the list being decorated, they are validated.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyPredicate` - the predicate to validate the keys, null means no check
    `valuePredicate` - the predicate to validate to values, null means no check
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

### getSortedMap

    protected java.util.SortedMap getSortedMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### firstKey

    public java.lang.Object firstKey()

  Specified by:
    `firstKey` in interface `java.util.SortedMap`

### lastKey

    public java.lang.Object lastKey()

  Specified by:
    `lastKey` in interface `java.util.SortedMap`

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedMap`

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Specified by:
    `subMap` in interface `java.util.SortedMap`

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Specified by:
    `headMap` in interface `java.util.SortedMap`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Specified by:
    `tailMap` in interface `java.util.SortedMap`

### entrySet

    public java.util.Set entrySet()

  Specified by:
    `entrySet` in interface `java.util.Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.